CCTL0:	EQU	0B7A6H

	ORG	200H

	DEFM	7FH,7FH,'TREE',1

	LD	HL,TREE
	LD	DE,(19<<8)+9*8
	LD	B,TREE_END-TREE

LOOP:

	LD	A,(HL)
	PUSH	HL
	CALL	PRINT_N
	POP	HL
	INC	HL

	DJNZ	LOOP

	RET

; A = width
;
PRINT_N:

	PUSH	BC

	LD	B,A
	SRL	A	; /2
	NEG	A
	ADD	19
	LD	D,A

	PUSH	DE

.PN_LOOP:

	CALL	PRINT

	DJNZ	.PN_LOOP

	POP	DE

	; next line
	LD	A,E
	ADD	8
	LD	E,A

	POP	BC

	RET

; DE = position
;
PRINT:

	PUSH	DE
	PUSH	BC

	SET	7,D	; video ram

	LD	HL,(CCTL0)
	LD	BC,('*'-32)*8
	ADD	HL,BC
	LD	BC,8
	LDIR

	POP	BC
	POP	DE

	INC	D

	RET

TREE:
	DEFB	1,3,5,7
	DEFB	3,7,11,15
	DEFB	5,11,17,23
	DEFB	3,3
TREE_END:
